function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useMemo } from 'react';
import Select from 'react-select';
import { useFormContext } from './CustomForm';
const CustomFormFieldSelect = ({
  options = [],
  value,
  onChange,
  isValid = true,
  noOptionMessage = 'Aucun résultat',
  placeholder = '',
  disabled = false,
  multi = false,
  fieldName = '',
  setFormField = () => {},
  ...props
}, ref) => {
  const {
    displayError
  } = useFormContext();
  const formattedValue = useMemo(() => !multi ? options.find(o => o.value === value) : options.filter(o => value.includes(o.value)), [value, options]);
  const handleChangeSelect = obj => {
    if (fieldName != '' && onChange == null) setFormField(fieldName, multi ? obj.map(({
      value
    }) => value) : obj.value);else if (onChange != null) onChange(obj);
  };
  const style = useMemo(() => getComputedStyle(document.body), []);
  return /*#__PURE__*/React.createElement(Select, _extends({
    className: `react-select ${!isValid && displayError ? 'is-invalid' : ''}`,
    value: formattedValue,
    onChange: handleChangeSelect,
    options: options,
    noOptionsMessage: () => noOptionMessage,
    placeholder: placeholder,
    isDisabled: disabled,
    isMulti: multi,
    theme: theme => {
      return {
        ...theme,
        borderRadius: '1rem',
        spacing: {
          ...theme.spacing,
          controlHeight: 50
        },
        colors: {
          ...theme.colors,
          primary: style.getPropertyValue('--bs-primary'),
          secondary: style.getPropertyValue('--bs-secondary')
        }
      };
    },
    styles: {
      option: (styles, data) => {
        const isFirst = data.options[0].value === data.value;
        const isLast = data.options[data.options.length - 1].value === data.value;
        if (isFirst) {
          styles.borderTopLeftRadius = '1rem';
          styles.borderTopRightRadius = '1rem';
        }
        if (isLast) {
          styles.borderBottomLeftRadius = '1rem';
          styles.borderBottomRightRadius = '1rem';
        }
        return styles;
      }
    }
  }, props));
};
export default CustomFormFieldSelect;